Logo AND Algorithmique Numérique Distribuée

Public GIT Repository
always have display_timing activated for smpi, as it is quite useful
[simgrid.git] / src / smpi / smpirun.in
index bcd1e93..861ed11 100755 (executable)
@@ -1,4 +1,7 @@
 #!/bin/bash
+
+@CMAKE_SMPI_COMMAND@
+
 DEFAULT_LOOPBACK_BANDWIDTH="498000000"
 DEFAULT_LOOPBACK_LATENCY="0.000004"
 DEFAULT_NETWORK_BANDWIDTH="$((26 * 1024 * 1024))"
@@ -10,9 +13,43 @@ LOOPBACK_BANDWIDTH="${DEFAULT_LOOPBACK_BANDWIDTH}"
 LOOPBACK_LATENCY="${DEFAULT_LOOPBACK_LATENCY}"
 NETWORK_BANDWIDTH="${DEFAULT_NETWORK_BANDWIDTH}"
 NETWORK_LATENCY="${DEFAULT_NETWORK_LATENCY}"
-NUMPROCS="${DEFAULT_NUMPROCS}"
 POWER="${DEFAULT_POWER}"
 
+SIMOPTS="--cfg=maxmin/precision:1e-9 --cfg=network/model:SMPI --cfg=network/TCP_gamma:4194304 --cfg=smpi/display_timing:1"
+
+#usage to print the way this script should be called
+function usage () {
+cat <<EOF
+Usage: $0 [OPTIONS] -platform <xmldesc> -hostfile <hostfile> program [program-options]
+Options:
+  -keep-temps                # don't remove the generated files after execution
+  -map                       # display the machine on which each process rank is mapped
+  -np <numprocs>             # use that amount of processes from the hostfile.
+                             # By default, all processes of the hostfile are used.
+  -trace                     # activate tracing
+  -trace-comment <comment>   # put a comment on the top of the trace file
+  -trace-comment-file <file> # put file contents on the top of the trace file as comment
+  -trace-grouped             # group MPI processes by location
+  -trace-resource            # trace resource utilization
+  -trace-viva               # generate configuration for Viva's GraphView
+  -trace-file <tracefile>    # name of the tracefile (simgrid_smpi.trace)
+  -ext <value>               # additional parameter (reserved)
+
+or (deprecated usage):
+  $0 [-keep-temps] [-np <numprocs>] [-bandwidth <bytes/sec>] [-latency <secs>] program [program-options]
+
+EOF
+}
+
+#check if we have at least one parameter
+if [ $# -eq 0 ]
+then
+    usage
+    exit
+fi
+
+EXTOPT=""
+
 while true; do
   case "$1" in
    "-np" | "-n")
@@ -29,19 +66,83 @@ while true; do
     ;;
    "-platform")
        PLATFORM="$2"
+      if [ ! -f "${PLATFORM}" ]; then
+               echo "[$0] ** error: the file '${PLATFORM}' does not exist. Aborting."
+               exit 1
+      fi
        shift 2
     ;;
    "-hostfile")
        HOSTFILE="$2"
+      if [ ! -f "${HOSTFILE}" ]; then
+               echo "[$0] ** error: the file '${HOSTFILE}' does not exist. Aborting."
+               exit 1
+      fi
        shift 2
     ;;
 
-   "-help" | "--help" | "-h") 
-      echo "usage:"
-      echo "$0 [-np <numprocs>] [-bandwidth <bytes/sec>] [-latency <secs>] [-platform <xmldesc>] [-hostfile <hostfile>] program [program-options]"
-      echo
+   "-ext")
+      EXTOPT="$2"
+      shift 2
+   ;;
+
+   "-map")
+       MAPOPT="true"
+      shift 1
+   ;;
+
+   "-trace")
+      TRACE_ACTIVE="true"
+      shift 1
+   ;;
+
+   "-trace-comment")
+      TRACE_COMMENT="$2"
+      shift 2
+   ;;
+
+   "-trace-comment-file")
+      TRACE_COMMENT_FILE="$2"
+      shift 2
+   ;;
+
+   "-trace-file")
+      TRACE_FILENAME="$2"
+      shift 2
+   ;;
+
+   "-trace-grouped")
+      TRACE_GROUPED="true"
+      shift 1
+   ;;
+
+   "-trace-resource")
+      TRACE_RESOURCE="true"
+      shift 1
+   ;;
+
+   "-trace-viva")
+       TRACE_VIVA="true"
+         shift 1
+   ;;
+
+   "-keep-temps")
+       KEEP="true"
+      shift 1
+   ;;
+
+   "-help" | "--help" | "-h")
+      usage
       exit
    ;;
+
+   "--cfg="*|"--log="*)
+     for OPT in ${1#*=}
+     do
+       SIMOPTS="$SIMOPTS ${1%%=*}=$OPT"
+     done
+     shift 1
+   ;;
     *)
       break
     ;;
@@ -51,15 +152,43 @@ done
 EXEC="$1"
 shift
 
+##-----------------------------------
+
+# Basic checks on the provided arguments
+if [ -z "${EXEC}" ] ; then
+    echo "You must provide a program to execute."
+    usage
+    exit 1
+fi
+
+if [ -z "${HOSTFILE}" ] ; then
+    echo "No hostfile specified."
+    usage
+    exit 1
+fi
+
+# Don't use wc -l to compute it to avoid issues with trailing \n at EOF
+hostfile_procs=`grep -c "[a-zA-Z0-9]" $HOSTFILE`
+
+if [ -z "${NUMPROCS}" ] ; then
+    # Use the amount of processes in the hostfile as default value for the -np parameter
+    NUMPROCS=$hostfile_procs
+fi
+
+
+if [ ${NUMPROCS} -gt ${hostfile_procs} ] ; then
+    echo "You requested to use ${NUMPROCS} processes, but there is only ${hostfile_procs} processes in your hostfile..." >&2
+fi
+
 ##-------------------------------- DEFAULT or SPECIFIED PLATFORM --------------------------------------
-if [ -z "${PLATFORM}" ]; then  
+if [ -z "${PLATFORM}" ]; then
        PLATFORMTMP="$(mktemp tmpXXXXXX)"
-       #PLATFORMTMP="pla.xml"
 
        cat > ${PLATFORMTMP} <<PLATFORMHEAD
 <?xml version='1.0'?>
-<!DOCTYPE platform SYSTEM "simgrid.dtd">
-<platform version="2">
+<!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid.dtd">
+<platform version="3">
+<AS id="AS0" routing="Full">
 PLATFORMHEAD
 
 for (( i=${NUMPROCS}; $i ; i=$i-1 )) do
@@ -71,14 +200,15 @@ done
 for (( i=${NUMPROCS}; $i ; i=$i-1 )) do
   for (( j=${NUMPROCS}; $j ; j=$j-1 )) do
     if [ $i -eq $j ]; then
-      echo "  <route src=\"host$i\" dst=\"host$j\"><link:ctn id=\"loop$i\"/></route>" >> ${PLATFORMTMP}
+      echo "  <route src=\"host$i\" dst=\"host$j\"><link_ctn id=\"loop$i\"/></route>" >> ${PLATFORMTMP}
     else
-      echo "  <route src=\"host$i\" dst=\"host$j\"><link:ctn id=\"link$i\"/><link:ctn id=\"link$j\"/></route>" >> ${PLATFORMTMP}
+      echo "  <route src=\"host$i\" dst=\"host$j\"><link_ctn id=\"link$i\"/><link_ctn id=\"link$j\"/></route>" >> ${PLATFORMTMP}
     fi
   done
 done
 
 cat >> ${PLATFORMTMP} <<PLATFORMFOOT
+</AS>
 </platform>
 PLATFORMFOOT
 
@@ -94,13 +224,25 @@ APPLICATIONTMP="$(mktemp tmpXXXXXX)"
 
 cat > ${APPLICATIONTMP} <<APPLICATIONHEAD
 <?xml version='1.0'?>
-<!DOCTYPE platform SYSTEM "simgrid.dtd">
-<platform version="2">
+<!DOCTYPE platform SYSTEM "http://simgrid.gforge.inria.fr/simgrid.dtd">
+<platform version="3">
 APPLICATIONHEAD
 
 ##---- cache hostnames of hostfile---------------
 if [ -n "${HOSTFILE}" ] && [ -f ${HOSTFILE} ]; then
        hostnames=(`cat ${HOSTFILE} | tr \\\n " "`)
+      NUMHOSTS=`cat ${HOSTFILE} | wc -l`
+fi
+
+if [ "${EXTOPT}" = "smpi_replay" ]; then
+  APP_TRACES=$1;
+  if [ -n "${APP_TRACES}" ] && [ -f "${APP_TRACES}" ]; then
+     hosttraces=(`cat ${APP_TRACES} | tr \\\n " "`)
+     NUMTRACES=`cat ${APP_TRACES} | wc -l`
+  else
+     printf "File not found: %s\n", "${APP_TRACES:-\${APP_TRACES}}" >&2
+     exit 1
+  fi
 fi
 
 ##----------------------------------------------------------
@@ -109,30 +251,50 @@ fi
 ##  in hostfile (where -hostfile hostfile), or "host$i" if
 ##  hostfile has less than i lines.
 ##----------------------------------------------------------
-for (( i=${NUMPROCS}; $i ; i=$i-1 )) do
-  j=$(( $i-1 ))
-  if [ -z "${hostnames[$j]}" ]; then
-       host="host"$i
-  else
-       host="${hostnames[$j]}"
+
+HAVE_SEQ="`which seq 2>/dev/null`"
+
+if [ -n "${HAVE_SEQ}" ]; then
+       SEQ=`${HAVE_SEQ} 0 $((${NUMPROCS}-1))`
+else
+      cnt=0
+       while (( $cnt < ${NUMPROCS} )) ; do
+           SEQ="$SEQ $cnt"
+           cnt=$((cnt + 1));
+       done
+fi
+
+##---- generate <process> tags------------------------------
+
+for i in ${SEQ}
+do
+  if [ -n "${HOSTFILE}" ]; then
+       j=$(( $i % ${NUMHOSTS} ))
+  fi
+  ##---- optional display of ranks to process mapping
+  if [ -n "${MAPOPT}" ]; then
+       echo "[rank $i] -> ${hostnames[$j]}"
   fi
-  echo "  <process host=\"${host}\" function=\"smpi_simulated_main\">" >> ${APPLICATIONTMP}
-  for ARG in $*; do
-    echo "    <argument value=\"${ARG}\"/>" >> ${APPLICATIONTMP}
-  done
-  echo "  </process>" >> ${APPLICATIONTMP}
-done
 
-for (( i=${NUMPROCS}; $i ; i=$i-1 )) do
-  j=$(( $i-1 ))
   if [ -z "${hostnames[$j]}" ]; then
-       host="host"$i
+       host="host"$(($j+1))
   else
        host="${hostnames[$j]}"
   fi
-  echo "  <process host=\"${host}\" function=\"smpi_sender\"/>" >> ${APPLICATIONTMP}
-  echo "  <process host=\"${host}\" function=\"smpi_receiver\"/>" >> ${APPLICATIONTMP}
+  echo "  <process host=\"${host}\" function=\"$i\"> <!-- function name used only for logging -->" >> ${APPLICATIONTMP}
+  echo "    <argument value=\"$i\"/> <!-- rank -->" >> ${APPLICATIONTMP}
+  if [ "${EXTOPT}" = "smpi_replay" ]; then
+    if  [ ${NUMTRACES} -gt 1 ]; then
+      echo "    <argument value=\"${hosttraces[$j]}\"/>" >> ${APPLICATIONTMP}
+    else
+      echo "    <argument value=\"${hosttraces[0]}\"/>" >> ${APPLICATIONTMP}
+    fi
+  else 
+    for ARG in $*; do
+       echo "    <argument value=\"${ARG}\"/>" >> ${APPLICATIONTMP}
+    done
+  fi
+  echo "  </process>" >> ${APPLICATIONTMP}
 done
 
 cat >> ${APPLICATIONTMP} <<APPLICATIONFOOT
@@ -140,10 +302,48 @@ cat >> ${APPLICATIONTMP} <<APPLICATIONFOOT
 APPLICATIONFOOT
 ##-------------------------------- end DEFAULT APPLICATION --------------------------------------
 
-${EXEC} ${PLATFORMTMP} ${APPLICATIONTMP}
+##---------------------- SMPI TRACING OPTIONS ---------------------------------
+if [ -n "${TRACE_ACTIVE}" ]; then
+  #define trace filename
+  if [ -z "${TRACE_FILENAME}" ]; then
+    TRACE_FILENAME="smpi_simgrid.trace"
+  fi
+  TRACEOPTIONS="--cfg=tracing:1 --cfg=tracing/filename:${TRACE_FILENAME} --cfg=tracing/smpi:1"
 
-echo "[$0] cleaning up temp files"
-if [ -z "${PLATFORM}" ]; then
-       rm ${PLATFORMTMP} 
+  if [ -n "${TRACE_COMMENT}" ]; then
+    TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment:${TRACE_COMMENT}"
+  fi
+
+  if [ -n "${TRACE_COMMENT_FILE}" ]; then
+    TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/comment_file:${TRACE_COMMENT_FILE}"
+  fi
+
+  if [ -n "${TRACE_GROUPED}" ]; then
+    TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/smpi/group:1"
+  fi
+
+  if [ -n "${TRACE_RESOURCE}" ]; then
+    TRACEOPTIONS="${TRACEOPTIONS} --cfg=tracing/categorized:1 --cfg=tracing/uncategorized:1"
+  fi
+
+  if [ -n "${TRACE_VIVA}" ]; then
+    TRACEOPTIONS="${TRACEOPTIONS} --cfg=viva/categorized:smpi_cat.plist --cfg=viva/uncategorized:smpi_uncat.plist"
+  fi
 fi
-rm ${APPLICATIONTMP}
+##---------------------- end SMPI TRACING OPTIONS ---------------------------------
+
+export SMPI_GLOBAL_SIZE=${NUMPROCS}
+if [ -n "${KEEP}" ] ; then
+  echo ${EXEC} ${SIMOPTS} ${TRACEOPTIONS} ${PLATFORMTMP} ${APPLICATIONTMP}
+fi
+${EXEC} ${SIMOPTS} ${TRACEOPTIONS} ${PLATFORMTMP} ${APPLICATIONTMP}
+status=$?
+
+if [ -z "${KEEP}" ] ; then
+   if [ -z "${PLATFORM}" ]; then
+       rm ${PLATFORMTMP}
+   fi
+   rm ${APPLICATIONTMP}
+fi
+
+exit $status